#ifndef BUILD_H
#define BUILD_H

#include "../fileProcess/fileprocess.h"
#include "../module/infocreatewidget.h"

#include <QProgressBar>
#include <QObject>
#include <QCoreApplication>
#include <QThread>
#include <QProcess>
#include <QDebug>
#include <QDir>

class build: public QThread
{
    Q_OBJECT
public:
    explicit build(QObject *parent = nullptr) : QThread(parent){}

protected:
    void run() override
    {
        //生成源码orig文件
        QProcess process1;
        QString dir1 = QDir::homePath() + "/.cache/theme-build/"+FileProcess::g_date;
        qDebug() << dir1;
        QString command1 = "tar";
        QStringList arguments1;
        arguments1 << "-zcvf" << FileProcess::g_themeENName+"_1.0.orig.tar.xz"
                   << "--exclude=.git" << "--exclude=debian" << FileProcess::g_date;


        process1.setWorkingDirectory(dir1);
        process1.start(command1, arguments1);

        QObject::connect(&process1, &QProcess::readyReadStandardOutput, [&]() {
            QString output = process1.readAllStandardOutput();
            qDebug() << "Output from tar: " << output;
        });

        process1.waitForFinished(-1);
        emit progressChanged(10);

        //编译
        QProcess process2;
        QString dir2 = QDir::homePath() + "/.cache/theme-build/" + FileProcess::g_date + "/src/";
        qDebug() << dir2;
        QString command2 = "debuild";
        QStringList arguments2;
        arguments2 << "-us"<<"-uc";

        process2.setWorkingDirectory(dir2);
        process2.start(command2, arguments2);

        // 连接debuild进程的输出信号和槽
        QObject::connect(&process2, &QProcess::readyReadStandardOutput, [&]() {
            QString output = process2.readAllStandardOutput();
            qDebug() << "Output from debuild: " << output;
            if(output=="dh clean\n"){
                emit progressChanged(20);
            }else if(output=="   dh_installdocs\n"){
                emit progressChanged(80);
            }else if(output=="   dh_builddeb\n"){
                emit progressChanged(90);
            }
        });

        // 等待debuild进程完成
        process2.waitForFinished(-1);
        // 完成后更新进度条的值为100
        emit progressChanged(100);
    }


signals:
    void progressChanged(int value);
};

#endif // BUILD_H
