#include "buildcheckwidget.h"

buildCheckWidget::buildCheckWidget(QWidget *parent)
    : QWidget(parent)
{
}

// 编译前拷贝必须文件
void buildCheckWidget::buildCopy(){

    m_debSourceFormat = ":/resource/debian/source/format";
    m_debRules = ":/resource/debian/rules";
    m_debCopyRight = ":/resource/debian/copyright";
    m_debCopyPostinst = ":/resource/debian/postinst";

    QString m_debPath = QDir::homePath() + "/.cache/theme-build/" + FileProcess::g_date + "/src";
    QDir m_debSource = m_debPath +"/debian/source";
    qDebug()<<m_debSource;
    m_debSource.mkdir(m_debSource.absolutePath());

    if (QFile::copy(m_debSourceFormat,m_debPath+"/debian/source/format") &&
        QFile::copy(m_debRules,m_debPath+"/debian/rules") &&
        QFile::copy(m_debCopyRight,m_debPath+"/debian/copyright") &&
        QFile::copy(m_debCopyPostinst,m_debPath+"/debian/postinst")){
        qDebug()<<"COPY SUCCESS";
    } else {
        qDebug()<<"COPY Failed";
        qDebug()<<QFile::copy(m_debSourceFormat,m_debPath+"/debian/source/format") ;
        qDebug()<<QFile::copy(m_debRules,m_debPath+"/debian/rules") ;
        qDebug()<<QFile::copy(m_debCopyRight,m_debPath+"/debian/copyright");
        qDebug()<<QFile::copy(m_debCopyPostinst,m_debPath+"/debian/postinst");
    }

}

void buildCheckWidget::buildForGlobal(){
    buildForIcon();
    buildForCursor();
    buildForPlymouth();
}

//图标打包
void buildCheckWidget::buildForIcon(){

    //创建打包目录
    QString m_buildIconThemePath = QDir::homePath() + "/.cache/theme-build/" + FileProcess::g_date + "/src/iconTheme/"
            + FileProcess::g_themeENName;
    QDir m_buildIconThemeDir = m_buildIconThemePath;
    m_buildIconThemeDir.mkdir(m_buildIconThemeDir.absolutePath());

    QFile m_iconIndex(m_buildIconThemePath+"/index.theme");
    QTextStream m_iconIndexStream(&m_iconIndex);
    //写入icon index.theme文件
    if (m_iconIndex.open(QIODevice::WriteOnly | QIODevice::Truncate | QIODevice::Text)) {
        qDebug()<< m_iconIndex;
        m_iconIndexStream << QStringLiteral("[Icon Theme]");
        m_iconIndexStream << endl << QStringLiteral("Name=")+ FileProcess::g_themeENName;
        m_iconIndexStream << endl << QStringLiteral("Comment=Icon theme for UKUI ,from moka.");
        m_iconIndexStream << endl << QStringLiteral("Inherits=ukui-icon-theme-default,gnome,hicolor,Adwaita");
        m_iconIndexStream << endl;

        m_iconIndexStream.flush();
        m_iconIndex.close();
    }

    //处理svg转png，获取svg文件
    QString m_buildAppIconPath = QDir::homePath() + "/.cache/theme-build/" + FileProcess::g_date + "/src/iconTheme/appicon/";
    QString m_buildSystemIconPath = QDir::homePath() + "/.cache/theme-build/" + FileProcess::g_date + "/src/iconTheme/systemicon/";
    QDir m_buildAppIconDir = m_buildAppIconPath;
    QDir m_buildSystemIconDir = m_buildSystemIconPath;

    // 设置过滤器，仅获取 .svg 文件
    QStringList m_appIconNameFilters;
    m_appIconNameFilters << "*.svg";
    m_buildAppIconDir.setNameFilters(m_appIconNameFilters);
    QStringList m_systemIconNameFilters;
    m_systemIconNameFilters << "*.svg";
    m_buildSystemIconDir.setNameFilters(m_systemIconNameFilters);

    // 获取源目录中的文件列表
    QStringList m_appIconfiles = m_buildAppIconDir.entryList(QDir::Files);
    QStringList m_systemIconfiles = m_buildSystemIconDir.entryList(QDir::Files);

    if(!m_appIconfiles.isEmpty()||!m_systemIconfiles.isEmpty()){

        QString m_iconThemeScalablePath = m_buildIconThemePath + "/scalable";
        QString m_iconThemeScalableAppsPath = m_iconThemeScalablePath + "/apps";
        QDir m_buildSystemIcondirDir = m_iconThemeScalablePath;
        QDir m_iconThemeScalableAppsDir = m_iconThemeScalableAppsPath;
        m_buildSystemIcondirDir.mkdir(m_buildSystemIcondirDir.absolutePath());
        m_iconThemeScalableAppsDir.mkdir(m_iconThemeScalableAppsDir.absolutePath());
        //写入icon index.theme文件
        if (m_iconIndex.open(QIODevice::WriteOnly | QIODevice::Append | QIODevice::Text)) {
            m_iconIndexStream << endl << QStringLiteral("# Directory list");
            m_iconIndexStream << endl << QStringLiteral("Directories=16x16/apps,24x24/apps,32x32/apps,48x48/apps,64x64/apps,96x96/apps,128x128/apps,256x256/apps,scalable/apps");
            m_iconIndexStream << endl << QStringLiteral("# Applications");
            m_iconIndexStream << endl << QStringLiteral("[scalable/apps]");
            m_iconIndexStream << endl << QStringLiteral("Context=Applications");
            m_iconIndexStream << endl << QStringLiteral("Size=16");
            m_iconIndexStream << endl << QStringLiteral("MinSize=16");
            m_iconIndexStream << endl << QStringLiteral("MaxSize=256");
            m_iconIndexStream << endl << QStringLiteral("Type=Scalable");
            m_iconIndexStream << endl;

            m_iconIndexStream.flush();
            m_iconIndex.close();
        }
        // 遍历文件列表并拷贝到目标目录
        foreach (const QString &m_appIconFile, m_appIconfiles) {
            QString sourceFilePath = m_buildAppIconDir.filePath(m_appIconFile);
            QString destinationFilePath = m_iconThemeScalableAppsDir.filePath(m_appIconFile);

            QFile sourceFile(sourceFilePath);
            QFile destinationFile(destinationFilePath);

            // 如果源文件可以打开，并且目标文件可以创建
            if (sourceFile.open(QIODevice::ReadOnly) && destinationFile.open(QIODevice::WriteOnly)) {
                // 从源文件读取数据
                QByteArray data = sourceFile.readAll();

                // 将数据写入目标文件
                destinationFile.write(data);

                // 关闭文件
                sourceFile.close();
                destinationFile.close();
            }
        }
        foreach (const QString &m_systemIconfile, m_systemIconfiles) {
            QString sourceFilePath = m_buildAppIconDir.filePath(m_systemIconfile);
            QString destinationFilePath = m_iconThemeScalableAppsDir.filePath(m_systemIconfile);

            QFile sourceFile(sourceFilePath);
            QFile destinationFile(destinationFilePath);

            if (sourceFile.open(QIODevice::ReadOnly) && destinationFile.open(QIODevice::WriteOnly)) {
                QByteArray data = sourceFile.readAll();
                destinationFile.write(data);
                sourceFile.close();
                destinationFile.close();
            }
        }

        QStringList m_svgFilters;
        m_svgFilters << "*.svg"; // 指定扩展名为 .svg

        m_iconThemeScalableAppsDir.setNameFilters(m_svgFilters);
        m_iconThemeScalableAppsDir.setFilter(QDir::Files | QDir::NoSymLinks);

        QFileInfoList m_svgFileInfoList = m_iconThemeScalableAppsDir.entryInfoList();

        // 遍历获取文件名
        foreach (QFileInfo m_svgFileInfo, m_svgFileInfoList) {
            QString m_fileName = m_svgFileInfo.fileName();

            //处理svg转png
            QSvgRenderer m_svgRenderer;
            m_svgRenderer.load(m_fileName);

            //遍历、创建尺寸目录，并拷贝生成png
            int array[] = {16, 24, 32, 48, 64, 96, 128, 256};
            int length = sizeof(array) / sizeof(array[0]);

            for (int i = 0; i < length; i++) {

                // 创建QImage对象并绘制SVG到不同尺寸的图像上
                QSize size(array[i],array[i]);
                QImage image(size, QImage::Format_ARGB32);
                QPainter painter(&image);
                painter.setRenderHint(QPainter::Antialiasing);
                m_svgRenderer.render(&painter, QRectF(0, 0, size.width(), size.height()));

                //生成尺寸目录
                QString m_imageDirThemeSizePath = m_buildIconThemePath +"/" + QString::number(array[i]) + "x" + QString::number(array[i]);
                QString m_imageDirThemeAppsPath = m_imageDirThemeSizePath+ "/apps";
                QDir m_imageThemeSizeDir = m_imageDirThemeSizePath;
                QDir m_imageDirThemeAppDir = m_imageDirThemeAppsPath;
                m_imageThemeSizeDir.mkdir(m_imageThemeSizeDir.absolutePath());
                m_imageDirThemeAppDir.mkdir(m_imageDirThemeAppDir.absolutePath());

                //拷贝图片
                m_fileName.replace(".svg", ".png");
                image.save(m_imageDirThemeAppsPath+"/"+m_fileName);

                if (m_iconIndex.open(QIODevice::WriteOnly | QIODevice::Append  | QIODevice::Text)) {
                    qDebug()<< m_iconIndex;
                    m_iconIndexStream << endl << QStringLiteral("[")+QString::number(array[i])+QStringLiteral("x")+QString::number(array[i])+QStringLiteral("/apps]");
                    m_iconIndexStream << endl << QStringLiteral("Context=Applications");
                    m_iconIndexStream << endl << QStringLiteral("Size=")+QString::number(array[i]);
                    m_iconIndexStream << endl << QStringLiteral("Type=Fixed");
                    m_iconIndexStream << endl;

                    m_iconIndexStream.flush();
                    m_iconIndex.close();
                }
            }
        }
    }else{
        qDebug()<<"svg images doesn't exits!!!";
    }



}

//光标打包
void buildCheckWidget::buildForCursor(){
    //创建打包目录
    QString m_buildcursorThemePath = QDir::homePath() + "/.cache/theme-build/" + FileProcess::g_date + "/src/cursorTheme/"
            + FileProcess::g_themeENName + "-cursor";
    QDir m_buildCursorThemeDir = m_buildcursorThemePath;
    m_buildCursorThemeDir.mkdir(m_buildCursorThemeDir.absolutePath());

    //写入icon index.theme文件
    QFile m_cursorIndex(m_buildcursorThemePath+"/index.theme");
    QTextStream m_cursorIndexStream(&m_cursorIndex);
    if (m_cursorIndex.open(QIODevice::WriteOnly | QIODevice::Truncate | QIODevice::Text)) {
        qDebug()<< m_cursorIndex;
        m_cursorIndexStream << QStringLiteral("[Icon Theme]");
        m_cursorIndexStream << endl << QStringLiteral("Name=") + FileProcess::g_themeENName + QStringLiteral("-cursor");
        m_cursorIndexStream << endl << QStringLiteral("Comment=cursor theme");
        m_cursorIndexStream << endl;

        m_cursorIndexStream.flush();
        m_cursorIndex.close();
    }
    //写入icon cursor.theme文件
    QFile m_cursorTheme(m_buildcursorThemePath+"/cursor.theme");
    QTextStream m_cursorThemeStream(&m_cursorTheme);
    if (m_cursorTheme.open(QIODevice::WriteOnly | QIODevice::Truncate | QIODevice::Text)) {
        qDebug()<< m_cursorTheme;
        m_cursorThemeStream << QStringLiteral("[Icon Theme]");
        m_cursorThemeStream << endl << QStringLiteral("Inherits=") + FileProcess::g_themeENName + QStringLiteral("-cursor");
        m_cursorThemeStream << endl;

        m_cursorIndexStream.flush();
        m_cursorTheme.close();
    }
    //编写cursor.sh
    QFile m_cursorShell(m_buildcursorThemePath+"/cursor.sh");
    QTextStream m_cursorShellStream(&m_cursorShell);
    if (m_cursorShell.open(QIODevice::WriteOnly |  QIODevice::Append | QIODevice::Text)) {
        qDebug()<< m_cursorShell;
        m_cursorShellStream << QStringLiteral("#!/bin/bash");
        m_cursorShellStream << endl << QStringLiteral("  mkdir cursors");

        m_cursorIndexStream.flush();
        m_cursorShell.close();
        m_cursorShell.setPermissions(QFile::ReadOwner | QFile::WriteOwner | QFile::ExeOwner |
                                     QFile::ReadUser | QFile::WriteUser | QFile::ExeUser |
                                     QFile::ReadGroup | QFile::WriteGroup | QFile::ExeGroup |
                                     QFile::ReadOther | QFile::WriteOther | QFile::ExeOther);
    }

    //处理svg转png，获取svg文件
    QString m_cursorIconPath = QDir::homePath() + "/.cache/theme-build/" + FileProcess::g_date + "/src/cursorTheme/cursor/";
    QString m_timeCursorIconPath = QDir::homePath() + "/.cache/theme-build/" + FileProcess::g_date + "/src/cursorTheme/timecursor/";
    QDir m_cursorIconDir = m_cursorIconPath;
    QDir m_timeCursorIconDir = m_timeCursorIconPath;

    // 设置过滤器，仅获取 .svg 文件
    QStringList m_cursorIconNameFilters;
    m_cursorIconNameFilters << "*.svg";
    m_cursorIconDir.setNameFilters(m_cursorIconNameFilters);
    QStringList m_timeCursorIconNameFilters;
    m_timeCursorIconNameFilters << "*.svg";
    m_timeCursorIconDir.setNameFilters(m_timeCursorIconNameFilters);

    // 获取源目录中的文件列表
    QStringList m_cursorIconfiles = m_cursorIconDir.entryList(QDir::Files);
    QStringList m_timeCursorIconfiles = m_timeCursorIconDir.entryList(QDir::Files);

    if(!m_cursorIconfiles.isEmpty()||!m_timeCursorIconfiles.isEmpty()){

        QString m_cursorThemeSVGPath = m_buildcursorThemePath + "/svg";
        QDir m_cursorThemeSVGDir = m_cursorThemeSVGPath;
        m_cursorThemeSVGDir.mkdir(m_cursorThemeSVGDir.absolutePath());
        // 遍历文件列表并拷贝到目标目录
        foreach (const QString &m_cursorIconfile, m_cursorIconfiles) {
            QString sourceFilePath = m_cursorIconDir.filePath(m_cursorIconfile);
            QString destinationFilePath = m_cursorThemeSVGDir.filePath(m_cursorIconfile);

            QFile sourceFile(sourceFilePath);
            QFile destinationFile(destinationFilePath);

            // 如果源文件可以打开，并且目标文件可以创建
            if (sourceFile.open(QIODevice::ReadOnly) && destinationFile.open(QIODevice::WriteOnly)) {
                // 从源文件读取数据
                QByteArray data = sourceFile.readAll();

                // 将数据写入目标文件
                destinationFile.write(data);

                // 关闭文件
                sourceFile.close();
                destinationFile.close();
            }
        }
        foreach (const QString &m_timeCursorIconfile, m_timeCursorIconfiles) {
            QString sourceFilePath = m_timeCursorIconDir.filePath(m_timeCursorIconfile);
            QString destinationFilePath = m_cursorThemeSVGDir.filePath(m_timeCursorIconfile);

            QFile sourceFile(sourceFilePath);
            QFile destinationFile(destinationFilePath);

            if (sourceFile.open(QIODevice::ReadOnly) && destinationFile.open(QIODevice::WriteOnly)) {
                QByteArray data = sourceFile.readAll();
                destinationFile.write(data);
                sourceFile.close();
                destinationFile.close();
            }
        }

        QStringList m_svgFilters;
        m_svgFilters << "*.svg"; // 指定扩展名为 .svg

        m_cursorThemeSVGDir.setNameFilters(m_svgFilters);
        m_cursorThemeSVGDir.setFilter(QDir::Files | QDir::NoSymLinks);

        QFileInfoList m_svgFileInfoList = m_cursorThemeSVGDir.entryInfoList();

        // 遍历获取文件名
        foreach (QFileInfo m_svgFileInfo, m_svgFileInfoList) {
            QString m_fileName = m_svgFileInfo.fileName();

            //处理svg转png
            QSvgRenderer m_svgRenderer;
            m_svgRenderer.load(m_fileName);

            //遍历、创建尺寸目录，并拷贝生成png
            int array[] = {24, 32, 48, 64};
            int length = sizeof(array) / sizeof(array[0]);
            QString m_deleteFileNameConclusion = m_fileName.chopped(4);
            QString m_fileNameTimeCursor = m_fileName.left(m_fileName.lastIndexOf('_'));

            for (int i = 0; i < length; i++) {

                // 创建QImage对象并绘制SVG到不同尺寸的图像上
                QSize size(array[i],array[i]);
                QImage image(size, QImage::Format_ARGB32);
                QPainter painter(&image);
                painter.setRenderHint(QPainter::Antialiasing);
                m_svgRenderer.render(&painter, QRectF(0, 0, size.width(), size.height()));

                //生成尺寸目录
                QString m_imageDirThemeSizePath = m_buildcursorThemePath +"/" + QString::number(array[i]) + "x" + QString::number(array[i]);
                QDir m_imageThemeSizeDir = m_imageDirThemeSizePath;
                m_imageThemeSizeDir.mkdir(m_imageThemeSizeDir.absolutePath());

                //拷贝图片
                m_fileName.replace(".svg", ".png");
                image.save(m_imageDirThemeSizePath+"/"+m_fileName);

                if(m_fileNameTimeCursor != "watch" && m_fileNameTimeCursor != "left_ptr_watch"){

                    if (m_cursorShell.open(QIODevice::WriteOnly | QIODevice::Append  | QIODevice::Text)) {
                        qDebug()<< m_cursorShell;
                        m_cursorShellStream << endl << QStringLiteral("  echo '")+QString::number(array[i])+QStringLiteral(" ")
                                               +QString::number(array[i]/2)+QStringLiteral(" ")+QString::number(array[i]/2)
                                               +QStringLiteral(" ")+QString::number(array[i])+QStringLiteral("x")+QString::number(array[i])
                                               +QStringLiteral("/")+m_deleteFileNameConclusion+QStringLiteral(".png 0 '>> cursors/")
                                               +m_deleteFileNameConclusion+QStringLiteral(".in");

                        m_cursorShellStream.flush();
                        m_cursorShell.close();
                    } else {
                        qDebug()<< m_cursorShell;
                    }
                } else {

                    if (m_cursorShell.open(QIODevice::WriteOnly | QIODevice::Append  | QIODevice::Text)) {
                        qDebug()<< m_cursorShell;
                        m_cursorShellStream << endl << QStringLiteral("  echo '")+QString::number(array[i])+QStringLiteral(" ")
                                               +QString::number(array[i]/2)+QStringLiteral(" ")+QString::number(array[i]/2)
                                               +QStringLiteral(" ")+QString::number(array[i])+QStringLiteral("x")+QString::number(array[i])
                                               +QStringLiteral("/")+m_deleteFileNameConclusion+QStringLiteral(".png 50 '>> cursors/")
                                               +m_fileNameTimeCursor+QStringLiteral(".in");

                        m_cursorShellStream.flush();
                        m_cursorShell.close();
                    } else {
                        qDebug()<< m_cursorShell;
                    }
                }
            }

            //处理光标文件生成
            if(m_fileNameTimeCursor != "watch" && m_fileNameTimeCursor != "left_ptr_watch"){
                if (m_cursorShell.open(QIODevice::WriteOnly | QIODevice::Append  | QIODevice::Text)) {
                    qDebug()<< m_cursorShell;
                    m_cursorShellStream << endl << QStringLiteral("  xcursorgen cursors/")+m_deleteFileNameConclusion+QStringLiteral(".in cursors/")+m_deleteFileNameConclusion;

                    m_cursorShellStream.flush();
                    m_cursorShell.close();
                } else {
                    qDebug()<< m_cursorShell;
                }
            } else {
                if (m_cursorShell.open(QIODevice::WriteOnly | QIODevice::Append  | QIODevice::Text)) {
                    qDebug()<< m_cursorShell;
                    m_cursorShellStream << endl << QStringLiteral("  xcursorgen cursors/")+m_fileNameTimeCursor+QStringLiteral(".in cursors/")+m_fileNameTimeCursor;

                    m_cursorShellStream.flush();
                    m_cursorShell.close();
                } else {
                    qDebug()<< m_cursorShell;
                }
            }

            //处理软连接
            if(m_deleteFileNameConclusion == "left_ptr"){
                if (m_cursorShell.open(QIODevice::WriteOnly | QIODevice::Append  | QIODevice::Text)) {
                    qDebug()<< m_cursorShell;
                    m_cursorShellStream << endl << QStringLiteral("  cd cursors/");
                    m_cursorShellStream << endl << QStringLiteral("  ln -s left_ptr move");
                    m_cursorShellStream << endl << QStringLiteral("  ln -s left_ptr dnd-move");
                    m_cursorShellStream << endl << QStringLiteral("  ln -s left_ptr grabbing");
                    m_cursorShellStream << endl << QStringLiteral("  ln -s left_ptr top_left_arrow");
                    m_cursorShellStream << endl << QStringLiteral("  ln -s left_ptr arrow");
                    m_cursorShellStream << endl << QStringLiteral("  cd ..");

                    m_cursorShellStream.flush();
                    m_cursorShell.close();
                } else {
                    qDebug()<< m_cursorShell;
                }
            } else if(m_deleteFileNameConclusion == "circle"){
                if (m_cursorShell.open(QIODevice::WriteOnly | QIODevice::Append  | QIODevice::Text)) {
                    qDebug()<< m_cursorShell;
                    m_cursorShellStream << endl << QStringLiteral("  cd cursors/");
                    m_cursorShellStream << endl << QStringLiteral("  ln -s circle crossed_circle");
                    m_cursorShellStream << endl << QStringLiteral("  cd ..");

                    m_cursorShellStream.flush();
                    m_cursorShell.close();
                } else {
                    qDebug()<< m_cursorShell;
                }

            } else if(m_deleteFileNameConclusion == "cross"){
                if (m_cursorShell.open(QIODevice::WriteOnly | QIODevice::Append  | QIODevice::Text)) {
                    qDebug()<< m_cursorShell;
                    m_cursorShellStream << endl << QStringLiteral("  cd cursors/");
                    m_cursorShellStream << endl << QStringLiteral("  ln -s cross crosshair");
                    m_cursorShellStream << endl << QStringLiteral("  ln -s cross cross_reverse");
                    m_cursorShellStream << endl << QStringLiteral("  ln -s cross diamond_cross");
                    m_cursorShellStream << endl << QStringLiteral("  cd ..");

                    m_cursorShellStream.flush();
                    m_cursorShell.close();
                } else {
                    qDebug()<< m_cursorShell;
                }

            } else if(m_deleteFileNameConclusion == "dnd-none"){
                if (m_cursorShell.open(QIODevice::WriteOnly | QIODevice::Append  | QIODevice::Text)) {
                    qDebug()<< m_cursorShell;
                    m_cursorShellStream << endl << QStringLiteral("  cd cursors/");
                    m_cursorShellStream << endl << QStringLiteral("  ln -s dnd-none kylin-move");
                    m_cursorShellStream << endl << QStringLiteral("  cd ..");

                    m_cursorShellStream.flush();
                    m_cursorShell.close();
                } else {
                    qDebug()<< m_cursorShell;
                }

            } else if(m_deleteFileNameConclusion == "dnd-copy"){
                if (m_cursorShell.open(QIODevice::WriteOnly | QIODevice::Append  | QIODevice::Text)) {
                    qDebug()<< m_cursorShell;
                    m_cursorShellStream << endl << QStringLiteral("  cd cursors/");
                    m_cursorShellStream << endl << QStringLiteral("  ln -s dnd-copy copy");
                    m_cursorShellStream << endl << QStringLiteral("  cd ..");

                    m_cursorShellStream.flush();
                    m_cursorShell.close();
                } else {
                    qDebug()<< m_cursorShell;
                }

            } else if(m_deleteFileNameConclusion == "dnd-link"){
                if (m_cursorShell.open(QIODevice::WriteOnly | QIODevice::Append  | QIODevice::Text)) {
                    qDebug()<< m_cursorShell;
                    m_cursorShellStream << endl << QStringLiteral("  cd cursors/");
                    m_cursorShellStream << endl << QStringLiteral("  ln -s dnd-link copy");
                    m_cursorShellStream << endl << QStringLiteral("  cd ..");

                    m_cursorShellStream.flush();
                    m_cursorShell.close();
                } else {
                    qDebug()<< m_cursorShell;
                }

            } else if(m_deleteFileNameConclusion == "dnd-ask"){
                if (m_cursorShell.open(QIODevice::WriteOnly | QIODevice::Append  | QIODevice::Text)) {
                    qDebug()<< m_cursorShell;
                    m_cursorShellStream << endl << QStringLiteral("  cd cursors/");
                    m_cursorShellStream << endl << QStringLiteral("  ln -s dnd-ask question_arrow");
                    m_cursorShellStream << endl << QStringLiteral("  cd ..");

                    m_cursorShellStream.flush();
                    m_cursorShell.close();
                } else {
                    qDebug()<< m_cursorShell;
                }

            } else if(m_deleteFileNameConclusion == "h_double_arrow"){
                if (m_cursorShell.open(QIODevice::WriteOnly | QIODevice::Append  | QIODevice::Text)) {
                    qDebug()<< m_cursorShell;
                    m_cursorShellStream << endl << QStringLiteral("  cd cursors/");
                    m_cursorShellStream << endl << QStringLiteral("  ln -s h_double_arrow left_side");
                    m_cursorShellStream << endl << QStringLiteral("  ln -s h_double_arrow right_side");
                    m_cursorShellStream << endl << QStringLiteral("  cd ..");

                    m_cursorShellStream.flush();
                    m_cursorShell.close();
                } else {
                    qDebug()<< m_cursorShell;
                }

            } else if(m_deleteFileNameConclusion == "v_double_arrow"){
                if (m_cursorShell.open(QIODevice::WriteOnly | QIODevice::Append  | QIODevice::Text)) {
                    qDebug()<< m_cursorShell;
                    m_cursorShellStream << endl << QStringLiteral("  cd cursors/");
                    m_cursorShellStream << endl << QStringLiteral("  ln -s v_double_arrow top_side");
                    m_cursorShellStream << endl << QStringLiteral("  ln -s v_double_arrow bottom_side");
                    m_cursorShellStream << endl << QStringLiteral("  cd ..");

                    m_cursorShellStream.flush();
                    m_cursorShell.close();
                } else {
                    qDebug()<< m_cursorShell;
                }

            } else if(m_deleteFileNameConclusion == "ul_angle"){
                if (m_cursorShell.open(QIODevice::WriteOnly | QIODevice::Append  | QIODevice::Text)) {
                    qDebug()<< m_cursorShell;
                    m_cursorShellStream << endl << QStringLiteral("  cd cursors/");
                    m_cursorShellStream << endl << QStringLiteral("  ln -s ul_angle top_left_corner");
                    m_cursorShellStream << endl << QStringLiteral("  ln -s ul_angle bd_double_arrow");
                    m_cursorShellStream << endl << QStringLiteral("  ln -s ul_angle bottom_right_corner");
                    m_cursorShellStream << endl << QStringLiteral("  ln -s ul_angle lr_angle");
                    m_cursorShellStream << endl << QStringLiteral("  cd ..");

                    m_cursorShellStream.flush();
                    m_cursorShell.close();
                } else {
                    qDebug()<< m_cursorShell;
                }

            } else if(m_deleteFileNameConclusion == "ur_angle"){
                if (m_cursorShell.open(QIODevice::WriteOnly | QIODevice::Append  | QIODevice::Text)) {
                    qDebug()<< m_cursorShell;
                    m_cursorShellStream << endl << QStringLiteral("  cd cursors/");
                    m_cursorShellStream << endl << QStringLiteral("  ln -s ur_angle top_right_corner");
                    m_cursorShellStream << endl << QStringLiteral("  ln -s ur_angle fd_double_arrow");
                    m_cursorShellStream << endl << QStringLiteral("  ln -s ur_angle bottom_left_corner");
                    m_cursorShellStream << endl << QStringLiteral("  ln -s ur_angle ll_angle");
                    m_cursorShellStream << endl << QStringLiteral("  cd ..");

                    m_cursorShellStream.flush();
                    m_cursorShell.close();
                } else {
                    qDebug()<< m_cursorShell;
                }

            }

        }

        //多余文件处理
        if (m_cursorShell.open(QIODevice::WriteOnly | QIODevice::Append  | QIODevice::Text)) {
            qDebug()<< m_cursorShell;
            m_cursorShellStream << endl << QStringLiteral("  rm cursors/*.in");

            m_cursorShellStream.flush();
            m_cursorShell.close();
        } else {
            qDebug()<< m_cursorShell;
        }
    }else{
        qDebug()<<"svg images doesn't exits!!!";
    }


}

//开机动画打包
void buildCheckWidget::buildForPlymouth(){
    QString m_buildPlymouthPath = QDir::homePath()+ "/.cache/theme-build/" + FileProcess::g_date + "/src/plymouthTheme/";
    QFile m_plymouthPic(m_buildPlymouthPath+"1.png");

    if(m_plymouthPic.exists()){
        for (int var = 2; var <= 72; ++var) {
            QString sourceFilePath =  m_plymouthPic.fileName();
            QString destinationFilePath =m_buildPlymouthPath + QString::number(var) + ".png";
            QFile::copy(sourceFilePath, destinationFilePath);
        }
    } else {

    }
}

//grub打包
void buildCheckWidget::buildForGrub(){
    QString m_buildGrubPath = QDir::homePath()+ "/.cache/theme-build/" + FileProcess::g_date + "/src/plymouthTheme/";
    QFile m_grubPic(m_buildGrubPath+"background.png");

    if(!m_grubPic.exists()){

    } else {

    }
}

//编译检查
void buildCheckWidget::buildCheck(QDir m_buildPath){
    //获取基础资源文件
//    QDir appicons = ":/resource/appicons/";
//    QDir systemIcons = ":/resource/systemicons";
//    QCryptographicHash hash(QCryptographicHash::Md5);

//    QStringList appIconFiles = appicons.entryList(QDir::Files);
//    foreach(QString appIconFile, appIconFiles){
//        appIconInfo[appIconFile] = appIconInfoID;
//        appIconInfoID++;
//    }
//    QStringList systemIconFiles = systemIcons.entryList(QDir::Files);
//    foreach(QString systemIconFile, systemIconFiles){
//        systemIconInfo[systemIconFile] = systemIconInfoID;
//        systemIconInfoID++;
//    }


//    if (m_buildPath.exists()) {
//        qDebug() << "开始遍历目录：" << m_buildPath.absolutePath();
//        buildCheckResult(m_buildPath);

//        for (auto it = appIconInfo.begin(); it != appIconInfo.end(); ++it) {
//            const QString appIconInfo = it.key();

//            // 检查是否 keyA 存在于 QMap B 中
//            if (!cacheIconInfo.contains(keyA)) {
//                // 如果 keyA 不存在于 QMap B 中，将其添加到 result
//                warning[keyA] = it.value();
//            }
//        }

//        if(buildCheckState == 0){
            buildCopy();

            if(FileProcess::g_createThemeType == "globalTheme"){
                buildForGlobal();
            } else if(FileProcess::g_createThemeType == "iconTheme"){
                buildForIcon();
            } else if(FileProcess::g_createThemeType == "cursorTheme"){
                buildForCursor();
            } else if(FileProcess::g_createThemeType == "plymouthTheme"){
                buildForPlymouth();
            } else if(FileProcess::g_createThemeType == "grubTheme"){
                buildForGrub();
            }

            buildWidget *m_buildWidget = new buildWidget();
            m_buildWidget->show();

            connect(m_buildWidget, &buildWidget::gohomesignals, this,[=](){
                //发送返回主界面信号给infocreatewidget
                emit gohomesignals();
            });
//        } else {
//            this->setFixedSize(424,480);
//            this->setWindowModality(Qt::ApplicationModal);

//            m_buildCheckWidget = new QVBoxLayout();
//            m_buildWarningMessage = new QLabel();
//            m_buildWarningMessage->setText("导出时检测到以下问题，请调整后重新导出:");
//            m_warningMessageList = new QLabel();
//            m_warningMessageList->setText("缺少以下素材：");

//            m_buildCheckBtnWidget = new QHBoxLayout();
//            m_buildBtn = new QPushButton();
//            m_buildBtn->setText("继续导出");
//            m_exitBuildBtn = new QPushButton();
//            m_exitBuildBtn->setText("返回");

//            m_buildCheckBtnWidget->addWidget(m_buildBtn);
//            m_buildCheckBtnWidget->addWidget(m_exitBuildBtn);
//            m_buildCheckWidget->addWidget(m_buildWarningMessage);
//            m_buildCheckWidget->addWidget(m_warningMessageList);
//            m_buildCheckWidget->addLayout(m_buildCheckBtnWidget);

//            this->setLayout(m_buildCheckWidget);
//            this->show();
//        }
//    } else {
//        qDebug() << "目录不存在：" << m_buildPath.absolutePath();
//    }
}

void buildCheckWidget::buildCheckResult(QDir m_buildPath){

    QString path = m_buildPath.absolutePath();
    QDir m_buildThemePath = path + "/" + FileProcess::g_createThemeType;
    // 设置过滤器，只获取文件和目录
    m_buildThemePath.setFilter(QDir::Files|QDir::Dirs| QDir::NoDotAndDotDot);

    // 获取目录下的所有文件和目录
    QFileInfoList fileList = m_buildThemePath.entryInfoList();
    qDebug()<<fileList;
    // 遍历文件和目录
    foreach(const QFileInfo& fileInfo, fileList)
    {
        qDebug()<<fileInfo;
        if (fileInfo.isFile()){
            if(FileCheck::isLegalIconFile(fileInfo.absoluteFilePath())){
//                cacheIconInfo[fileInfo] = cacheIconInfoID;
//                cacheIconInfoID++;

            } else {
                qDebug() << "warning:" << fileInfo.absoluteFilePath();
                buildCheckState--;
            }
        } else if (fileInfo.isDir()){
            buildCheckResult(QDir(fileInfo.absoluteFilePath()));
        } else {
            qDebug() << "warning:" << fileInfo.absoluteFilePath();
            buildCheckState--;
        }
    }
}
