#ifndef CURSORTHEMEFEATURE_H
#define CURSORTHEMEFEATURE_H

#include <QObject>
#include <QWidget>
#include <QPushButton>
#include <QVBoxLayout>
#include <QButtonGroup>
#include <QPainter>
#include <QScrollArea>
#include <QLabel>
#include <QMap>
#include <QDebug>
#include <QFileDialog>
#include <QStackedWidget>
#include <QWheelEvent>
#include <QDir>
#include <QFileInfo>
#include <QApplication>
#include <QGraphicsScene>
#include <QGraphicsView>
#include <QDebug>
#include <QKeyEvent>
#include <QWheelEvent>
#include <QtMath>
#include <QGraphicsPixmapItem>
#include <QPixmap>
#include <QGraphicsBlurEffect>

class CursorCustomLabel : public QLabel
{
public:
    explicit CursorCustomLabel(QWidget* parent = nullptr);

    void setPixmap(const QPixmap& pixmap);

protected:
    void paintEvent(QPaintEvent* event) override;

private:
    QPixmap pixmap;

};

class CursorEditWidget : public QWidget
{
    Q_OBJECT
public:
    CursorEditWidget(QWidget *parent = nullptr);
    void setdefaulticon(QString iconname);
    void setcustomicon(QString iconFilePath);

    QPushButton *m_addiconbutton;

private:
    QHBoxLayout *m_iconwidgetlayout;
    QLabel *m_icondefaultlabel;
    CursorCustomLabel *m_icondecustomlabel;
    QLabel *m_tiplabel;

};

class CursorGraphicsView : public QGraphicsView
{
public:
    explicit CursorGraphicsView(QGraphicsScene* scene);

protected:
    void wheelEvent(QWheelEvent* event) override;

};

class CursorImageWidget : public QWidget
{
public:
    CursorImageWidget(QWidget *parent = nullptr, const QMap<QString,QString>* iconMap = nullptr);
    void updateIcon(const QString& widgetName, const QString& newFilePath);

    void updateImage(const QString& imagePath);
    void updateIconMap(const QMap<QString, QString>* newIconMap);
    void setIconMap(QMap<QString,QString>*);

private:
    const QMap<QString,QString>* m_iconMap;
    CursorGraphicsView* graphicsView;
    QString m_coverFilePath;

};


class CursorThemeFeature : public QWidget
{
    Q_OBJECT
public:
    explicit CursorThemeFeature(QWidget *parent = nullptr, const QMap<QString,QString>* iconMap = nullptr);

signals:

};

#endif // CURSORTHEMEFEATURE_H
