#ifndef GLOBALTHEMEFEATURE_H
#define GLOBALTHEMEFEATURE_H

#include <QObject>
#include <QWidget>
#include <QVBoxLayout>
#include <QApplication>
#include <QGraphicsScene>
#include <QGraphicsView>
#include <QDebug>
#include <QKeyEvent>
#include <QWheelEvent>
#include <QtMath>
#include <QGraphicsProxyWidget>
#include <QPushButton>

class RoundedWidget : public QWidget
{
    Q_OBJECT

public:
    RoundedWidget(QWidget *parent = nullptr);

    void setRadius(int radius);
    void setTransparency(int transparency);
    void setBackgroundColor(const QColor& color);

protected:
    void paintEvent(QPaintEvent *event) override;

private:
    int m_radius;
    double m_transparency;
    QColor backgroundColor = Qt::white;    // 背景颜色
    QColor borderColor = Qt::white;        // 边框颜色
    int borderWidth = 1;                    // 边框宽度
};

class RoundedButton : public QPushButton {
public:
    RoundedButton(QWidget *parent = nullptr);

    void setRadius(int radius);

protected:
    void paintEvent(QPaintEvent *event) override;

private:
    int m_radius;
};

class CustomGraphicsView : public QGraphicsView {
public:
    explicit CustomGraphicsView(QGraphicsScene* scene);

protected:
    void wheelEvent(QWheelEvent* event) override;
};

class GlobalImageWidget : public QWidget {
public:
    GlobalImageWidget(QWidget *parent = nullptr, const QString& coverFilePath = "");
    void updateWidgetRadius(int sliderValue);
    void updateButtonColor(const QColor& color);
    void updateWidgetBackgroundColor(const QColor& color);
    void update(const QString& coverFilePath);
    void updateOverlayImage(const QString& overlayImagePath);
    void updatescale();
    void updateControlRadius(int Value);
    void updateTransparency(int transparency);
    void updatescale1();
private:
    CustomGraphicsView* graphicsView;
    QString m_coverFilePath;
    RoundedWidget *m_showwidget;
    RoundedButton *m_showbtn;
    QGraphicsScene* m_scene;
    QPixmap m_mergedImage;
    QPixmap m_image;
    QGraphicsProxyWidget* m_proxy;
};

class Globalthemefeature : public QWidget {
    Q_OBJECT
public:
    explicit Globalthemefeature(QWidget *parent = nullptr, const QString& coverFilePath = "");

signals:

};

#endif // GLOBALTHEMEFEATURE_H
