#ifndef GRUBTHEMEFEATURE_H
#define GRUBTHEMEFEATURE_H

#include <QObject>
#include <QApplication>
#include <QWidget>
#include <QGraphicsScene>
#include <QGraphicsPixmapItem>
#include <QGraphicsView>
#include <QVBoxLayout>
#include <QWheelEvent>
#include <QPainter>
#include <QtMath>

class GrubGraphicsView : public QGraphicsView {
public:
    explicit GrubGraphicsView(QGraphicsScene* scene);

protected:
    void wheelEvent(QWheelEvent* event) override;
//    void drawBackground(QPainter *painter, const QRectF &rect) override;


};

class GrubImageWidget : public QWidget {
public:
    GrubImageWidget(QWidget *parent = nullptr);
    void updateBackground(const QString& imagePath);
private:
    GrubGraphicsView* graphicsView;

    QGraphicsScene* m_scene;
    QPixmap m_mergedImage;
    QPixmap m_image;
    QGraphicsPixmapItem* m_backgroundItem;

    QPixmap m_overlayPixmap;
    QGraphicsPixmapItem* m_overlayItem;
    QGraphicsProxyWidget* m_proxy;
};

class GrubThemeFeature : public QWidget
{
    Q_OBJECT
public:
    explicit GrubThemeFeature(QWidget *parent = nullptr);

signals:

};

#endif // GRUBTHEMEFEATURE_H
