﻿#ifndef HISTORYWIDGET_H
#define HISTORYWIDGET_H

#include "../fileProcess/historyinfoload.h"

#include <QObject>
#include <QWidget>
#include <QDir>
#include <QDebug>
#include <QDateTime>
#include <QGridLayout>
#include <QPushButton>
#include <QLabel>
#include <QMenu>
#include <QAction>
#include <QMouseEvent>

class HistoryButton : public QPushButton
{
    Q_OBJECT
public:
    HistoryButton(QWidget* parent = nullptr);
    void setHistoryTime(const QString &text);
    void setCover(const QString &covePath);
    void setThemeName(const QString &themeName);
    void setThemeType(const QString &themeType);
    void initUI();

signals:
    void updateHistoryRequested();

private:
    QString m_historytime = nullptr;
    QString m_coverpath = nullptr;
    QString m_themename  = nullptr;
    QString m_themetype  = nullptr;
    QMenu *m_menu;

};


class HistoryWidget : public QWidget
{
    Q_OBJECT
public:
    explicit HistoryWidget(QWidget *parent = nullptr);
    void updateHistoryDir();

public slots:
    void handleButtonClick();

signals:
    void startSecondEdit(const HistoryInfo &InfoData);
    void updateInfo();

};

#endif // HISTORYWIDGET_H
