#ifndef MAININTERFACEFEATURE_H
#define MAININTERFACEFEATURE_H

#include <QObject>
#include <QWidget>
#include <QPushButton>
#include <QVBoxLayout>
#include <QButtonGroup>
#include <QPainter>
#include <QScrollArea>
#include <QLabel>
#include <QMap>
#include <QDebug>
#include <QFileDialog>
#include <QStackedWidget>
#include <QWheelEvent>
#include <QApplication>
#include <QGraphicsScene>
#include <QGraphicsView>
#include <QDebug>
#include <QKeyEvent>
#include <QWheelEvent>
#include <QtMath>
#include <QGraphicsPixmapItem>
class MainInterFaceFeature : public QWidget
{
    Q_OBJECT
public:
    explicit MainInterFaceFeature(QWidget *parent = nullptr);

};

class TypeButton : public QPushButton
{
public:
    TypeButton(QWidget *parent = nullptr);

protected:
    void paintEvent(QPaintEvent *event) override;

};


class IconGraphicsView : public QGraphicsView {
public:
    explicit IconGraphicsView(QGraphicsScene* scene);

protected:
    void wheelEvent(QWheelEvent* event) override;
};
class ImageWidget : public QWidget {
public:
    ImageWidget(QWidget *parent = nullptr, const QMap<QString,QString>* iconMap = nullptr);
    void updateIcon(const QString& widgetName, const QString& newFilePath);
    void updateImage(const QString& imagePath);
    void updateIconMap(const QMap<QString, QString>* newIconMap);
private:
    const QMap<QString,QString>* m_iconMap;
    QPixmap* image;
    IconGraphicsView* graphicsView;
    QString m_coverFilePath;
};

class CustomLabel : public QLabel {
public:
    explicit CustomLabel(QWidget* parent = nullptr);

    void setPixmap(const QPixmap& pixmap);

protected:
    void paintEvent(QPaintEvent* event) override;

private:
    QPixmap pixmap;
};

class IconEditWidget : public QWidget
{
    Q_OBJECT
public:
    IconEditWidget(QWidget *parent = nullptr);
    void setdefaulticon(QString iconname);
    void setdefaulticonname(QString iconname);
    void setcustomicon(QString iconFilePath);
    QLabel *m_label;
    QPushButton *m_addiconbutton;

private:

    QLabel *m_icondefaultlabel;
    CustomLabel *m_icondecustomlabel;

};
#endif // MAININTERFACEFEATURE_H
