#ifndef PLYMOUTHTHEMEFEATURE_H
#define PLYMOUTHTHEMEFEATURE_H

#include <QObject>
#include <QApplication>
#include <QWidget>
#include <QGraphicsScene>
#include <QGraphicsPixmapItem>
#include <QGraphicsView>
#include <QVBoxLayout>
#include <QWheelEvent>
#include <QPainter>
#include <QtMath>
#include <QLabel>

class PlymouthGraphicsView : public QGraphicsView {
public:
    explicit PlymouthGraphicsView(QGraphicsScene* scene);

protected:
    void wheelEvent(QWheelEvent* event) override;
    void drawBackground(QPainter *painter, const QRectF &rect) override;


};

class PlymouthImageWidget : public QWidget {
public:
    PlymouthImageWidget(QWidget *parent = nullptr);
    void updatePlymouth(const QString& imagePath);
private:
    PlymouthGraphicsView* graphicsView;
    QGraphicsScene* scene;
    QGraphicsPixmapItem* pixmapItem;
    QVBoxLayout* layout;
    QLabel *gif_anim;
    QGraphicsProxyWidget *proxy;
};

class PlymouthThemeFeature : public QWidget
{
    Q_OBJECT
public:
    explicit PlymouthThemeFeature(QWidget *parent = nullptr);

signals:

};

#endif // PLYMOUTHTHEMEFEATURE_H
