#ifndef PLYMOUTHMOUTHTHEMEWIDGET_H
#define PLYMOUTHMOUTHTHEMEWIDGET_H
#include "plymouththemefeature.h"
#include "iconwidgetfeature.h"

#include <QObject>
#include <QWidget>
#include <QPushButton>
#include <QVBoxLayout>
#include <QScrollArea>
#include <QLabel>
#include <QCheckBox>


class PlymouthThemeWidget : public QWidget
{
    Q_OBJECT
public:
    explicit PlymouthThemeWidget(QWidget *parent = nullptr);
    void initPreviewWidget();
    void initRightWidget();
    void addspaceritem();
    void initEditWidget();
    void setThumbnailIcon(QString path);
    static bool g_themeChange;
signals:
    void newPlymouthFilePath(const QString& path);
private:
    QWidget *m_previewwidget;
    PlymouthImageWidget *m_preview;
    QWidget *m_rightwidget;
    QWidget *m_plymouthwidget;
    QVBoxLayout *m_previewlayout;
    CustomLabel *m_customLabel;
};

#endif // PLYMOUTHMOUTHTHEMEWIDGET_H
